hdu 1348 Wall (凸包)

Wall

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 3139    Accepted Submission(s): 888


Problem Description
Once upon a time there was a greedy King who ordered his chief Architect to build a wall around the King's castle. The King was so greedy, that he would not listen to his Architect's proposals to build a beautiful brick wall with a perfect shape and nice tall towers. Instead, he ordered to build the wall around the whole castle using the least amount of stone and labor, but demanded that the wall should not come closer to the castle than a certain distance. If the King finds that the Architect has used more resources to build the wall than it was absolutely necessary to satisfy those requirements, then the Architect will loose his head. Moreover, he demanded Architect to introduce at once a plan of the wall listing the exact amount of resources that are needed to build the wall.
Your task is to help poor Architect to save his head, by writing a program that will find the minimum possible length of the wall that he could build around the castle to satisfy King's requirements.



The task is somewhat simplified by the fact, that the King's castle has a polygonal shape and is situated on a flat ground. The Architect has already established a Cartesian coordinate system and has precisely measured the coordinates of all castle's vertices in feet.
 
Input
The first line of the input file contains two integer numbers N and L separated by a space. N (3 <= N <= 1000) is the number of vertices in the King's castle, and L (1 <= L <= 1000) is the minimal number of feet that King allows for the wall to come close to the castle.

Next N lines describe coordinates of castle's vertices in a clockwise order. Each line contains two integer numbers Xi and Yi separated by a space (-10000 <= Xi, Yi <= 10000) that represent the coordinates of ith vertex. All vertices are different and the sides of the castle do not intersect anywhere except for vertices.
 
Output
Write to the output file the single number that represents the minimal possible length of the wall in feet that could be built around the castle to satisfy King's requirements. You must present the integer number of feet to the King, because the floating numbers are not invented yet. However, you must round the result in such a way, that it is accurate to 8 inches (1 foot is equal to 12 inches), since the King will not tolerate larger error in the estimates.

This problem contains multiple test cases!

The first line of a multiple input is an integer N, then a blank line followed by N input blocks. Each input block is in the format indicated in the problem description. There is a blank line between input blocks.

The output format consists of N output blocks. There is a blank line between output blocks.
 
Sample Input
1
9 100
200 400
300 400
300 300
400 300
400 400
500 400
500 200
350 200
200 200
 
Sample Output
1628
 
Source
 
Recommend
JGShining   |   We have carefully selected several similar problems for you:  2150 1147 1558 1374 1756 
 
题目给出一个城堡的所有角的坐标,求离城堡距离不小于L的城墙的最小长度。

 简单凸包,题意和我的想法有点出入,既然是要求最小的长度,就不是简单的凸包可以解决的,额,忽略细节的话就是凸包模板题。

求凸包的长度+半径为L的圆的周长。

 1 //31MS     256K    1479B     G++
 2 #include<stdio.h>
 3 #include<stdlib.h>
 4 #include<math.h>
 5 #define N 1005
 6 #define pi 3.1415926
 7 struct node{
 8     double x,y;
 9 }p[N],stack[N];
10 double dist(node a,node b)
11 {
12     return sqrt((a.y-b.y)*(a.y-b.y)+(a.x-b.x)*(a.x-b.x));
13 }
14 double crossprod(node a,node b,node c)
15 {
16     return ((b.x-a.x)*(c.y-a.y)-(c.x-a.x)*(b.y-a.y))/2;
17 }
18 int cmp(const void*a,const void*b)
19 {
20     node c=*(node*)a;
21     node d=*(node*)b;
22     double k=crossprod(p[0],c,d);
23     if(k<0 || !k && dist(p[0],c)>dist(p[0],d))
24         return 1;
25     return -1;
26 }
27 double graham(int n)
28 {
29     for(int i=1;i<n;i++)
30         if(p[i].x<p[0].x || p[i].x==p[0].x && p[i].y<p[0].y){
31             node temp=p[0];
32             p[0]=p[i];
33             p[i]=temp;
34         }
35     qsort(p+1,n-1,sizeof(p[0]),cmp);
36     p[n]=p[0];
37     for(int i=0;i<3;i++) stack[i]=p[i];
38     int top=2;
39     for(int i=3;i<n;i++){
40         while(crossprod(stack[top-1],stack[top],p[i])<=0 && top>=2)
41             top--;
42         stack[++top]=p[i];
43     }
44     double ans=dist(stack[0],stack[top]);
45     for(int i=0;i<top;i++)
46         ans+=dist(stack[i],stack[i+1]);
47     return ans;
48 }
49 int main(void)
50 {
51     int t,n;
52     double l;
53     scanf("%d",&t);
54     while(t--)
55     {
56         scanf("%d%lf",&n,&l);
57         for(int i=0;i<n;i++)
58             scanf("%lf%lf",&p[i].x,&p[i].y);
59         double ans=2*l*pi;
60         ans+=graham(n);
61         printf("%.0lf
",ans);
62         if(t) printf("
");
63     }
64     return 0;
65 }
原文地址:https://www.cnblogs.com/GO-NO-1/p/3770147.html